// =========================================================
// Аплет, который получает список всех аплетов
// и управляет аплетом Audio
//
// (C) Фролов А.В, 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            или
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;
import java.util.*;

// Импортируем класс Audio, так как нам нужен доступ к 
// его полям
import Audio;

public class Inspector extends Applet
{
  // Контекст аплетов
  AppletContext appContext;

  // Список аплетов, расположенных в документе HTML
  Enumeration eApplets;

  // Ссылка на аплет Audio
  Audio appAudio = null;

  // Кнопка для однократного проигрывания
  Button btPlay;

  // Кнопка для проигрывания в цикле
  Button btLoop;

  // Кнопка для остановки проигрывания
  Button btStop;

	// -------------------------------------------------------
  // getAppletInfo
  // Метод, возвращающей строку информации об аплете
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: Inspector\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

  // -------------------------------------------------------
  // init
  // Вызывается во время инициализации аплета
  // -------------------------------------------------------
	public void init()
	{
      // Создаем кнопку для однократного проигрывания
    btPlay = new Button("Play");

    // Создаем кнопку для проигрывания в цикле
    btLoop = new Button("Loop");

    // Создаем кнопку для остановки проигрывания
    btStop = new Button("Stop");

    // Блокируем эту кнопку, так как пока еще
    // проигрывание не запущено
    btStop.disable();

    // Добавляем кнопки в окно аплета
    add(btPlay);
    add(btLoop);
    add(btStop);
  }
  
  // -------------------------------------------------------
  // paint
  // Метод paint, выполняющий рисование в окне аплета
  // -------------------------------------------------------
  public void paint(Graphics g)
	{
    // Определяем текущие размеры окна аплета
    Dimension dimAppWndDimension = size();
    
    // Выбираем в контекст отображения желтый цвет
    g.setColor(Color.yellow);
    
    // Закрашиваем внутреннюю область окна аплета
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // Выбираем в контекст отображения черный цвет
    g.setColor(Color.black);

    // Рисуем рамку вокруг окна аплета
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    // Получаем контекст аплетов
    appContext = getAppletContext();
    
    // Получаем список всех аплетов в документе HTML
    eApplets = appContext.getApplets();

    // Сбрасываем счетчик цикла
    int i = 0;
    
    // Цикл по аплетам
    while(eApplets.hasMoreElements())
    {
      // Имя текущего аплета
      String appName;
      
      // Получаем ссылку на очередной аплет
      Applet currentApplet = (Applet)(eApplets.nextElement());

      // Получаем строу информации об аплете
      appName = currentApplet.getAppletInfo();

      // Обрезаем строку, удаляя символ конца строки
      StringTokenizer st;
      st   = new StringTokenizer(appName, "\r\n");
      appName = new String((String)st.nextElement());
      
      // Отображаем имя найденного аплета
      g.drawString(appName , 10, 15 * i + 50);

      // Если нашли аплет Audio, запоминаем ссылку
      // на него в поле appAudio
      if(appName.equals("Name: Audio"))
      {
        appAudio = (Audio)currentApplet;
      }

      // Увеличиваем счетчик аплетов
      i++;
    }
	}

  // -------------------------------------------------------
  // action
  // Метод вызывается, когда пользователь выполняет
  // действие над компонентами
  // -------------------------------------------------------
  public boolean action(Event evt, Object obj)
  {
    // Ссылка на кнопку, от которой пришло сообщение
    Button btn;

    // Проверяем, что событие вызвано кнопкой, а не
    // другим компонентом
    if(evt.target instanceof Button)
    {
      // Получам ссылку на кнопку, вызвавшую событие
      btn = (Button)evt.target;

      // Выполняем ветвление по кнопкам
      
      // Нажата кнопка однократного проигрывания
      if(evt.target.equals(btPlay))
      {
        // Запускаем однократное проигрывание
        appAudio.auClip.play();

        // Разблокируем кнопку остановки проигрывания
        btStop.enable();
      }

      // Нажата кнопка проигрывания в цикле
      else if(evt.target.equals(btLoop))
      {
        // Запускаем проигрывание в цикле
        appAudio.auClip.loop();

        // Разблокируем кнопку остановки проигрывания
        btStop.enable();
      }

      // Нажата кнопка остановки проигрывания
      else if(evt.target.equals(btStop))
      {
        // Останавливаем проигрывание
        appAudio.auClip.stop();

        // Блокируем кнопку остановки проигрывания
        btStop.disable();
      }

      // Если событие возникло от неизвестной кнопки,
      // мы его не обрабатываем
      else
      {
        return false;
      }

      // Возвращаем признак того, что мы обработали событие
      return true;
    }

    // Если событие вызвано не кнопкой, 
    // мы его не обрабатываем
    return false;
  }
}
